#include "book-index.h"
#include <iostream>

namespace pass_by_value
{
   void start_chapter(litindex::BookIndex b)
   {
      std::cout << "start_chapter(litindex::BookIndex b)\n";

      b.next_chapter();
      b.out();  // print status
   }
}

namespace pass_by_reference
{
   void start_chapter(litindex::BookIndex& b)
   {
      std::cout << "start_chapter(litindex::BookIndex& b)\n";

      b.next_chapter();
      b.out();  // print status
   }

   void start_chapter(litindex::BookIndex* b)
   {
      std::cout << "start_chapter(litindex::BookIndex* b)\n";

      b->next_chapter();
      b->out();  // print status
   }
}

int main()
{
   litindex::BookIndex idx;
   idx.chapter = 1;
   idx.section = 8;
   idx.page = 25;
   
   // print status
   //
   idx.out();
   
   using namespace pass_by_value;
   start_chapter(idx); // pass book index by value

   // print status
   //
   idx.out();
}
